{                           CUSTOM.PAS
  Tiedostossa mritellyt aliohjelmat:

  JononPrioriteetti(...);
  PinonPrioriteetti(...);
  VoikoOllaPerakkain(...);
    Muuta(...);
  Etumerkki(...);
}

{ Aliohjelma palauttaa Parametrin prioriteetin. Aliohjelmaa kutsutaan
  InfixToSuffix-aliohjelmasta, kun pit selvitt merkkijonosta lytyneen
  tokenin prioriteetti. Aliohjelman palauttamaa prioriteettia verrataan
  funktion PinonPrioriteetti palauttamaan arvoon ja siit ptelln,
  mihin jrjestykseen uusi, jonosta lydetty token ja pinon plimminen
  token tulevat RPN-jonoon. Prioriteettien arvot on otettu J. Tremplay'n
  kirjasta 'Theory and Practice Of Compiler Writing, Chapter 7'.

  Aliohjelman toimintaperiaate on seuraava:

    kydn silmukassa lpi kaikki FunktioTieto-taulukkoon talletetut
    funktiot, ja jos token lytyy sielt, niin asetetaan sen prioriteetti
    palautettavaksi. Jos token ei ole FunktioTieto-taulukossa, niin
    Case-lauseella kydn lpi muut mahdolliset kohdat. Jos mikn vaih-
    toehdoista ei pde, ilmoitetaan kyttjlle virheest ja PALATAAN
    KYTTJRJESTELMN (ohjelmakoodissa on pakko olla tllin vika).
}
  Function JononPrioriteetti(Mika : FunktioTyyppi { token, joka on lydetty }
                                                  { merkkijonosta. }
                                                 ) : Integer;
  Var  i : Integer;       { silmukkalaskuri }
       Loytyi : Boolean;  { lippu tokenin lytymisest silmukassa }
  Begin
    Loytyi:=False;
    For i:=1 To FunktioidenLukuMaara Do
     If Mika = FunktioTieto[i].Tyyppi Then Begin
       Loytyi:=True;
       JononPrioriteetti:= FunktioTieto[i].f;
     End;
   If Not Loytyi Then
     Case Mika Of
       Plus,Minus : JononPrioriteetti:=10;
       Mul,Divi   : JononPrioriteetti:=30;
       UMinus     : JononPrioriteetti:=55;
       Pot        : JononPrioriteetti:=60;
       Vakio      : JononPrioriteetti:=70;
       Muuttuja   : JononPrioriteetti:=70;
       VasenSulku : JononPrioriteetti:=90;
       OikeaSulku : JononPrioriteetti:=00;
       Else Begin { Bug in program }
         Bug('JononPrioriteetti');
       End; { Bug in program }
     End; { Case }
   End; { JononPrioriteetti }

{ Aliohjelma parauttaa parametrin prioriteetin. Parametri on InfixToSuffix-
  aliohjelmassa olevan apupinon huipun arvo (= joskus lausekkeesta lytynyt
  token). Aliohjelman palauttamaa prioriteettia verrataan funktion Jonon-
  Prioriteetti palauttamaan arvoon ja vertailun perusteella ptetn
  mihin jrjestykseen kyseiset tokenit tulevat RPN-jonoon.

  Prioriteettien arvot on otettu J. Tremplay'n kirjasta 'Theory and
  Practice of Compiler Writing'.

  Aliohjelman toimintaperiaate on seuraava:

    kydn silmukassa lpi kaikki FunktioTieto-taulukkoon talletetut
    funktiot, ja jos token lytyy sielt, niin asetetaan sen prioriteetti
    palautettavaksi. Jos token ei ole FunktioTieto-taulukossa, niin
    Case-lauseella kydn lpi muut mahdolliset kohdat. Jos mikn vaih-
    toehdoista ei pde, ilmoitetaan kyttjlle virheest ja PALATAAN
    KYTTJRJESTELMN (ohjelmakoodissa on pakko olla tllin vika).
}
  Function PinonPrioriteetti(Mika : FunktioTyyppi { token joka on apupinon }
                                                  { plimmisen }
                                                 ) : Integer;
  Var  i : Integer;       { silmukkalaskuri }
       Loytyi : Boolean;  { lippu tokenin lytymisest funktioiden joukosta }
  Begin
    Loytyi:=False;
    For i:=1 To FunktioidenLukuMaara Do
     If Mika = FunktioTieto[i].Tyyppi Then Begin
       Loytyi:=True;
       PinonPrioriteetti:= FunktioTieto[i].g;
     End;
   If Not Loytyi Then
     Case Mika Of
       Plus,Minus : PinonPrioriteetti:=20;
       Mul,Divi   : PinonPrioriteetti:=40;
       Pot        : PinonPrioriteetti:=50;
       UMinus     : PinonPrioriteetti:=55;
       Vakio      : PinonPrioriteetti:=80;
       Muuttuja   : PinonPrioriteetti:=80;
       VasenSulku : PinonPrioriteetti:=00;
       Else Begin { Bug in program }
         Bug('PinonPrioriteetti');
       End; { Bug in program }
     End; { Case }
   End; { PinonPrioriteetti }


{ Aliohjelmalla tutkitaan, voiko kaksi oliota olla perkkin aritmeettisessa
  lausekkeessa. Tutkittavat olioryhmt ovat:
    Funk     : funktion nimi
    Variable : muutuja TAI vakio
    VasSulk  : vasen sulkumerkki
    OikSulk  : oikea sulkumerkki
    EtuM     : etumerkki
    AritOper : aritmeettinen operaattori ( + - * / ^ )

  Aliohjelmaa kutsutaan InfixToSuffix-aliohjelmasta, kun pit selvit-
  t, onko annettu lauseke syntaksiltaan mieleks.

  Toimintaperiaate on seuraava:
       Muutetaan aluksi muuttujat Eka ja Toka (annetusta lausekkeesta
       lytyneit tokeneita) funktiolla Muuta OlioRyhmat -tyyppiin
       (mrittely alla) ja kytetn sitten nit arvoja Arvot-taulu-
       kon indeksein. Taulukko on tyypitetty vakio, jossa on boolean
       arvot siten, ett jos indeksein olevat tokenit voivat olla
       perkkin, niin taulukossa on ko. kohdalla True, muuten False.
}
Function VoikoOllaPerakkain(Eka, Toka : FunktioTyyppi) : Boolean;

Type   OlioRyhmat = (Funk,Variable,VasSulk,OikSulk,EtuM,AritOper);

Const  Arvot : Array[OlioRyhmat,OlioRyhmat] Of Boolean =
{              Funk,  Variable, VasSulk, OikSulk, EtuM,  ArtOper          }
{  Funk    } ((False, False,    True,    False,   False, False),
{ Variable }  (False, False,    False,   True,    False, True),
{ VasSulk  }  (True,  True,     True,    False,   True,  False),
{ OikSulk  }  (False, False,    False,   True,    False, True),
{ EtuM     }  (True,  True,     False,   False,   True,  False),
{ AritOper }  (True,  True,     True,    False,   True,  False));


  { Aliohjelmalla ryhmitelln Muutettava taulukon indeksisksi. }
  Function Muuta(Muutettava : FunktioTyyppi) : OlioRyhmat;
  Begin
    If Muutettava In [Sini..Arctani] Then Muuta:=Funk
    Else If Muutettava In [Vakio,Muuttuja] Then Muuta:=Variable
    Else If Muutettava = VasenSulku Then Muuta:=VasSulk
      Else If Muutettava = OikeaSulku Then Muuta:=OikSulk
        Else If Muutettava In [Divi,Mul,Pot,Plus,Minus] Then Muuta:=AritOper
          Else If Muutettava = UMinus Then Muuta:=EtuM
  End; { Muuta }

Begin { VoikoOllaPerakkain }
  VoikoOllaPerakkain:=Arvot[Muuta(Eka),Muuta(Toka)];
End;  { VoikoOllaPerakkain }


{ Aliohjelmalla tutkitaan, onko lytynyt - merkki etumerkki. - Tulkitaan
  etumerkiksi, jos sen edell on ollut jokin aritmeettinen operaattori
  tai vasen sulku. Muissa tapauksissa - tulkitaan vhennyslaskuksi.
}
Procedure Etumerkki(Var Jalkimmainen : FunktioTyyppi;
                        Ensimmainen  : FunktioTyyppi);
Begin
  If (Jalkimmainen = Minus) And (Ensimmainen In
    [Divi,Mul,VasenSulku,Pot,Plus,Minus]) Then Jalkimmainen:=UMinus;
End;  { Etumerkki }
