{                        INTOSUF.PAS
  Tiedostossa mritellyt aliohjelmat:

  OtaNumero(...);
    ErotaReal(...);
  InfixToSuffix(...);
    OtaOperaattori(...);
    OtaFunktio(...);
    OtaVakio(...);
}
{ Aliohjelmalla muutetaan Infix-merkkijonosta lytynyt vakio reaali-
  tai kompleksiluvuksi. Kutsuttaessa on muuttujassa i osoitin merkki-
  Jonoon siihen kohtaan, miss ensimminen numero on lydetty. Numero
  pttyy, kun lytyy jokin 'ei'-numero. 'e' ja '.' hyvksytn nume-
  roon ja tarkistetaan, ett ne ovat OK. 'e' merkitsee eksponenttia;
  piste on normaali desimaalipiste.

  Algoritmi:  1) Ota reaaliluku
              2) Tarkista onko kompleksiluku
                 A) tarkista kompleksiluvun syntaksi (a,b)
                 B) muodosta kompleksiluku
              3) muodosta reaaliluku

  Kutsuttavat aliohjelmat:   ErotaReal(...);  Mritelty OtaNumero:n lo-
                                              kaaliksi aliohjelmaksi.
                                              - tiedostossa INTOSUF.PAS
                             Exit;            TurboPascalissa mritelty.

}
    Procedure OtaNumero(    Jono   : Anystring;  { tulkattava merkkijono     }
                        Var i      : Integer;    { osoitin ekaan numeroon    }
                        Var Numero : Luku;       { lydetty luku numeerisena }
                        Var Error  : Integer);   { virheparametri: osoittaa  }
                                                 { merkkijonossa siihen koh- }
                                                 { taan, jossa virhe havait- }
                                                 { tiin.                     }

    Const  KompleksiPilkku = ',';                { reaali- ja imaginaariosan }
                                                 { erotusmerkki kompleksilu- }
                                                 { vuissa.                   }
           ImaginaariYksikko = 'i';              { imaginaariyksikn merkki. }
    Var    ApuLuku   : Real;                { Kenties tarpeeton apumuuttuja. }
           j         : Integer;  { Indeksi Jono:oon kompleksitarkistuksessa. }
           EtuMerkki : Boolean;                       { Lytyik etumerkki ? }



{ Aliohjelma erottaa Jonosta yhden reaaliluvun ja muuttaa sen numeeriseksi
  Val -proceduren kutsulla. Jos Val aiheuttaa virheen, palataan kyttjr-
  jestelmn, sill numerojono on valmiiksi erotettu, eik mitn virhett
  osata odotaa, eik ksitell...

  Algoritmi:  1) Etsi numerojonon loppu
              2) Val(...) -kutsulla muodosta luku

  Kutsuttavat aliohjelmat:   Val(...);      TurboPascalissa mritelty
                             Exit;                 ''           ''
                             Copy(...);            ''           ''

}
      Procedure ErotaReal(    Jono  : AnyString;  { ksiteltv merkkijono    }
                          Var i     : Integer;    { osoitin ekaan numeroon    }
                          Var Arvo  : Real;       { lydetty luku numeerisena }
                          Var Error : Integer);   { virhemuuttuja: osittaa    }
                                                  { virheen kohtaan merkkijo- }
                                                  { nossa.                    }

      Const  DesimaaliPiste = '.';     { Merkki, jolla erotetaan reaaliluvun }
                                       { kokonais ja desimaaliosat.          }
      Var    Virhe : Integer;          { Val(...) -proceduren kutsussa tar-  }
                                       { vittava virheparametri.             }
             j : Integer;              { Apuindeksi merkkijonoon.            }
             Numerot : Set Of Char;    { Sislt kaikki digitit; katso alla. }
      Begin
        Numerot:=['0','1','2','3','4','5','6','7','8','9'];
        j:=i;                 { j osoittaa ensimmiseen digittiin numerossa. }
        While Jono[j] In Numerot Do j:=Succ(j);    { etsitn numeron loppua }
        If Jono[j] = DesimaaliPiste Then Begin  { jos lytyi desimaalipiste, }
          j:=Succ(j);           { ohitetaan se ja jatketaan lopun etsimist. }
          While Jono[j] In Numerot Do j:=Succ(j);             { etsint.... }
        End;                                         { lytyi desimaalipiste }
        If Jono[j] = 'e' Then Begin             { Hyvksytn exponenttimer- }
          j:=Succ(j);                           { kinnt luvuissa.           }
          If Jono[j] In ['-','+'] Then j:=Succ(j);
          While Jono[j] In Numerot Do
            j:=Succ(j);
        End;                                     { lytyi exponentimerkint. }
        Val(Copy(Jono,i,j-i),Arvo,Virhe);          { kytetn Val-kutsua... }
        If Virhe <> 0 Then Begin
          Error:=Pred(j);
          Exit;
        End;                                          { virhe Val -kutsussa. }
        i:=j;
      End; { Erota Real }

Begin { OtaNumero }
  j:=Pred(i);          { j osoittaa ensimmist numeroa edeltvn merkkiin. }
  ErotaReal(Jono,i,ApuLuku,Error);
  If Error > 0 Then   { virheen sattuessa poistutaan Exit:ll aliohjelmasta. }
    Exit;
  While Jono[i] = ' ' Do
    i:=Succ(i); { Ohitetaan vlilynnit jonosta }
  If Jono[i] = kompleksiPilkku Then Begin
    If j > 1 Then begin   { tarkistetaan, ett merkkijonoa on ennen          }
                          { viittausta merkkijono alkuun.                    }
      If (Jono[j] = '(') Or ((Jono[j] = '-') And (Jono[j-1] = '(')) Then
      Begin  { Koska edell on lydetty kompleksipilkku, niin tarkistetaan   }
             { viel, ett kompleksiluvun syntaksi on oikea:  (A,B)          }
             { Etumerkit sallitaan molemmissa osissa.                        }
        Numero.Tyyppi:=Complexi;
        Numero.Cplx.Re:=ApuLuku;
        i:=Succ(i);
        While Jono[i] = ' ' Do
          i:=Succ(i); { Ohitetaan vlilynnit }
        EtuMerkki:= Jono[i] = '-';
        If EtuMerkki Then i:=Succ(i);
        ErotaReal(Jono,i,Numero.Cplx.Im, Error);
        If Error > 0 Then  { Jos on lytynyt virhe, niin poistutaan ali-     }
          Exit;            { ohjelmasta.                                     }
        If Not EtuMerkki Then Numero.Cplx.Im:= - Numero.Cplx.Im;
        If Jono[i] <> ')' Then Begin  { Jos kompleksiluku ei pty sulkuun,  }
          Error:=Pred(i);             { niin sen syntaksi on virheellinen.   }
          Exit;
        End; { ei loppusulkua }
      End { kompleksiluvun alkuosa oli oikein. }
      Else Begin { tai sitten ei ollut... }
        Error:=Pred(i);
        Exit;
      End; { kompleksiluvulla vr syntaksi. }
    End { merkkijonoa oli ennen kompleksilukua; syntaksi tarkistus voitiin   }
        { suorittaa.                                                         }
    Else  Begin  { Ennen oletettua kompleksilukua on < 2 merkki.            }
      If j = 1 Then  { Jos on vain yksi merkki ....                          }
        If Jono[j] = '(' Then Begin  { ja se on '(', niin komplesi on        }
          Numero.Tyyppi:=Complexi;   { Asetetaan tyyppi oikein ja reaaliosa  }
          Numero.Cplx.Re:=ApuLuku;   { paikalleen.                           }
          i:=Succ(i);
          EtuMerkki:= Jono[i] = '-';
          If EtuMerkki Then
            i:=Succ(i);
          ErotaReal(Jono,i,Numero.Cplx.Im, Error);
          If Error > 0 Then  { Jos tuli virhe, niin poistutaan aliohjelmasta. }
            Exit;
          If EtuMerkki Then
            Numero.Cplx.Im:= - Numero.Cplx.Im;
          If Jono[i] <> ')' Then Begin  { Jos lopusta ei lydy sulkua, niin  }
            Error:=Pred(i);             { kompleksiluvussa on syntaksivirhe. }
            Exit;
          End; { ei sulkua kompleksiluvun lopussa. }
        End { alussa oli '(' }
        Else Begin  { alussa ei ollut '(' -merkki -> virhe syntaksissa.     }
          Error:=Pred(i);
          Exit;
        End; { virheellinen syntaksi. }
    End { ennen oletettua kompleksilukua oli < 2 merkki. }
  End { lytyi kompleksipilkku .... }
  Else If Jono[i] = ImaginaariYksikko Then Begin { Jos onkin pelkk imag.    }
    Numero.Tyyppi:=Complexi;                     { yksikk.                  }
    Numero.Cplx.Re:=0.0;
    Numero.Cplx.Im:=ApuLuku;
    i:=Succ(i);
  End  { oli pelkk imag. yksikk. }
  Else Begin  { jljelle ji pelkk reaaliluvun mahdollisuus. }
    Numero.Tyyppi:=Reali;
    Numero.Arvo:=ApuLuku;
  End;  { oli "vain" reaaliluku. }
End; { Ota Numero }



{ Aliohjelmalla muutetaan Infix-merkkijono RPN-jonoksi. Algoritmi on
  lydettviss mm. J. Tremblayn kirjasta 'Theory and Practice of
  Compiler Writing'. Aputietorakenteena kytetn pinoa ja RPN:n
  tietorakenne on dynaaminen jono. Lydetty algoritmia ei ole viilattu
  mihinkn suuntaan, joten pienell ajattelulla homma varmasti nopeutuu,
  joskaan nopeuttamiseen ei liene mitn tarvetta, sill yleens
  lauseke tarvitsee knt vain kerran ja siihen kuluu ainoastaan
  muutama sadasosa sekunti.

  Algoritmi:

      1) Alustetaan:
         - aputietorakenne (pino)
         - listn lausekkeeseen ')' loppuun
           - syntaksitarkistuksen takia
         - RPN-jono
      2) Toista
         - hae seuraava token lausekkeesta
         - tarkista etumerkin oikeellisuus
         - tarkista syntaksi
           - voiko aikaisemmin lydetty token ja uusi token olla
             perkkin mielekkss(?) aritmeettisessa lausekkeessa
         - vertaa uutta tokenia ja pinon plimmist tokenia ja toista
           kunnes uusi token on prioriteetiltaan suurempi
           - jokaisella tokenilla on kaksi prioriteettia:
             - toista kytetn, kun token on uusi (juuri eristetty
               lausekkeesta) ja toista kytetn kun token on aputietoraken-
               teessa. Prioriteettien avulla mrtn mihin jrjestykseen
               tokenit tulevat RPN-jonoon.
             - prioriteetit saadaan funktioilla JononPrioriteetti ja
               Pinonprioriteetti (tiedostossa CUSTOM.PAS).
           - jos prioriteetit = --> poistu sisimmst silmukasta
         Kunnes koko merkkijono on kyty lpi

  Kutsuttavat aliohjelmat:
              SeuraavaFunktio(...);      Ottaa seuraavan tokenin lausekkeesta
                                         - tiedostossa INTOSUF.PAS
              Etumerkki(...);            Tarkista etumerkin
                                         - tiedostossa CUSTOM.PAS
              VoikoOllaPerakkain(...);   Syntaksitarkistus
                                         - tiedostossa CUSTOM.PAS
              JononPrioriteetti(...);    Uuden tokenin prioriteetti
                                         - tiedostossa CUSTOM.PAS
              PinonPrioriteetti(...);    Apurakenteessa olevan tokenin priori-
                                         teetti
                                         - tiedostossa CUSTOM.PAS
              Exit;                      TurboPascalissa mritelty
}
Procedure InfixToSuffix(Var Infix : AnyString; Var Jono : FunktioJono;
                        Var Virhe : Integer);

Label PoisSilmukasta;  { Alohjelman tarvitsema nimi silmukasta poistumiseen }

Type  Stack = ^Kasa;   { Aputietorakenne muutosoperaatiossa. Voidaan korvata }
      Kasa  = Record   { tekemll aliohjelmasta rekursiivinen. }
                Alkio : FunktioTyyppi;
                Seuraava : Stack;
              End; { Kasa }

Var   i    : Integer;  { Osoitin Infix -lausekkeeseen }
      Pino,
      Top  : Stack;             { Osoittimia aputietorakenteeseen }
      JononLoppu : FunktioJono; { apuosoitin muodostettavan listan loppuun }
      Temp,                        { Apumuuttuja muutosoperaatiossa. }
      Last,
      Next : FunktioTyyppi;     { kaksi viimeisint tokenia lausekkeesta }
      RightParen : Boolean;     { oikea sulku ? }
      Numero : Luku;            { lydetty numero }
      Index : VakioIndex;       { osoitin vakiotaulukkoon }





{ Aliohjelmalla etsitn Infix-jonosta seuraava funktio. Tss tapauksessa
  mys + - *... jne. on funktio; samoinkuin lukuvakiot, jotka nekin ovat
  funktioita. Ne vain palauttavat arvonsa pinoon.

  Algoritmi:  1) Alusta muuttujat
              2) Onko numero ?
              3) Onko operaattori ?
              4) Onko funktio ?
              5) Onko vakio ?

  Kutsuttavat aliohjelmat:
              OtaNumero(...);          Ottaa yhden numeron merkkijonosta
                                       - tiedostossa INTOSUF.PAS
              OtaOperaattori(...);     Ottaa yhden aritm. operaattorin
                                       merkkijonosta
                                       - tiedostossa INTOSUF.PAS
              OtaFunktio(...);         Tarkistaa, onko merkkijono funktion
                                       nimi
                                       - tiedostossa INTOSUF.PAS
              OtaVakio(...);           Tarkistaa, onko merkkijono vakion nimi
                                       - tiedostossa INTOSUF.PAS
              Exit;                    TurboPascalissa mritelty
}
  Procedure SeuraavaFunktio(Jono         : AnyString;  { ksiteltv lauseke }
                            Var i        : Integer;  { osoitin lausekkeeseen }
                            Var Seuraava : FunktioTyyppi; { uusi token       }
                            Var Numero   : Luku;     { mahd. uusi lukuvakio  }
                            Var Index    : VakioIndex; { Osoitin vakiotauluk- }
                                                     { koon. }
                            Var Error    : Integer); { virheparametri }

  Const  Space = ' ';
  Var    Numerot : Set Of Char;       { Sislt kaikki digitit }
         Operaattorit : Set Of Char;  { Sislt kaikki laskuoperaattorit. }
                                      { Tss operaattoreiksi katsotaan mys }
                                      { sulut }
         Oper,                        { Lydetty operaattori }
         Mika : FunktioTyyppi;        { Lydetty funktio }
         Oli : Boolean;               { Lytyik funktio vai ei? }
         Alku : Integer;              { tunnistamattoman merkkijonon alku }

{ Aliohjelma nappaa Infix-merkkijosta aritmeettisen operaattorin.

  Kutsuttavat aliohjelmat:
              Exit;                     TurboPascalissa mritelty
}
    Procedure OtaOperaattori(    Jono  : AnyString;    { ksiteltv lauseke }
                             Var i     : Integer;   { osoitin lausekkeeseen }
                             Var Mika  : FunktioTyyppi; { uusi token }
                             Var Error : Integer);      { virheparametri }
    Begin { Ota Operaattori }
      Case Jono[i] Of
        '+' : Mika:=Plus;
        '-' : Mika:=Minus;
        '/' : Mika:=Divi;
        '*' : Mika:=Mul;
        '^' : Mika:=Pot;
        '(' : Mika:=VasenSulku;
        ')' : Mika:=OikeaSulku;
        Else Begin
          Error:=Pred(i);
          Exit;
        End;
      End; { Case }
      i:=Succ(i);
    End; { Ota Operaattori }

{ Aliohjelmalla otetaan selville seuraavan alkeisfunktion nimen ja
  tarkistaa, ett se on laillinen. Samalla asetetaan funktion tunnus
  muuttujaan LydettyFunktio.

  Algoritmi:  1) Etsi kirjainjonon loppu
              2) Tarkista, onko funktio olemassa
                 A) jos on --> merkkaa lydetyksi ja palauta tyyppi

  Kutsutut aliohjelmat:
           Copy(...);                 TurboPascalissa mritelty
}
     Procedure OtaFunktio(    Jono  : AnyString;  { ksiteltv lauseke }
                          Var i     : Integer;    { osoitin lausekkeeseen }
                          Var LoydettyFunktio : FunktioTyyppi; { uusi token }
                          Var Oli   : Boolean);   { lytyik funktio ? }

     Var   Kirjaimet : Set Of Char;   { Apumuuttuja kirjaimien erotukseen }
           Mahdollinen : AnyString;   { Erotettu merkkijono }
           j : Integer;               { Apuindeksi merkkijonoon }
     Begin
       j:=i;
       Kirjaimet:=['a'..'z','','',''];
       While Jono[j] In Kirjaimet Do j:=Succ(j);
       Mahdollinen:=Copy(Jono,i,j-i);
       i:=j;
       Oli:=False;
       For j:=1 To FunktioidenLukuMaara Do Begin
         If FunktioTieto[j].Nimi = Mahdollinen Then Begin
           Oli:=True;
           LoydettyFunktio:=FunktioTieto[j].Tyyppi;
         End;
       End;
     End; { OtaFunktio }


{ Aliohjelmalla erotetaan toistaiseksi tunnistamaton merkkijono
  lausekkeesta ja tutkitaan, onko se jokin vakio. Jos vakio
  lydetn, sen osoitin VakionArvot taulukossa asetetaan laskenta-
  jonoon.
}
    Procedure OtaVakio(    Jono     : AnyString;  { ksiteltv merkkijono }
                       Var i        : Integer;    { osoitin merkkijonoon }
                       Var OliVakio : Boolean;    { oliko vakio ? }
                       Var Index    : VakioIndex; { osoitin vakiotaulukkoon }
                       Var Error    : Integer);   { virheparametri }

    Var  j : Integer;              { apumuuttuja kirjaijonon erotuksessa }
         Mahdollinen : AnyString;  { kopioitu kirjainjono (mahdollinen   }
                                   { vakion nimi)                        }
         Kirjaimet : Set Of Char;  { nm hyvksytn nimeen (a - )     }

    Begin  { Ota Vakio }
      j:=i;
      Kirjaimet:= ['a'..'z','','',''];
      While Jono[i] In Kirjaimet Do i:=Succ(i);
      Mahdollinen:=Copy(Jono,j,i-j);
      OliVakio:=False;
      For j:=1 To VakioOsoitin Do Begin
        If VakioArvot[j].Nimi = Mahdollinen Then Begin
          OliVakio:=True;
          Index:=j;
        End;
      End;
      If Not OliVakio Then Begin
        Error:=Pred(i);
        Exit;
      End;
    End; { OtaVakio }

  Begin { Seuraava Funktio }
    Numerot:=['0','1','2','3','4','5','6','7','8','9'];
    Operaattorit:=['+','-','*','/','^','(',')'];
    While Jono[i] = Space Do i:=Succ(i);
    If Jono[i] In Numerot Then Begin
      OtaNumero(Jono,i,Numero,Error);
      If Error > 0 Then Exit;
      Seuraava:=Vakio;
    End { numero lydetty }
    Else If Jono[i] In Operaattorit Then Begin
      OtaOperaattori(Jono,i,Oper,Error);
      If Error > 0 Then
        Exit;
      Seuraava:=Oper;
    End { operaattori lydetty }
    Else Begin  { siis funktio tai vakio ... }
      Alku:=i;
      OtaFunktio(Jono,i,Mika,Oli);
      If Oli Then Seuraava:=Mika
      Else Begin { pakko olla vakio ( tai virhe ) }
        OtaVakio(Jono,Alku,Oli,Index,Error);
        If Error > 0 Then
          Exit;
        i:=Alku;
        If Oli Then Seuraava:=Muuttuja;
      End;  { oli vakio (tai sitten ei) }
    End; { funktio tai vakio ... }
  End; { Seuraava Funktio }


Begin { Infix To Suffix }
  Virhe:=0;      { Oletuksena on, ett virhett ei tule. }
  New(Top);
  Infix:=Concat(Infix,')');   { Testauksen helpottamisesksi ympridn }
  Top^.Seuraava:=Nil;         { merkkijono suluilla (vasen sulku tulee  }
  Top^.Alkio:=VasenSulku;     { valmiiksi apupinoon).                   }
  Pino:=Top;
  Next:=VasenSulku;
  New(Jono);
  Jono^.Seuraava:=Nil;        { Alustetaan jono valmiiksi }
  JononLoppu:=Jono;
  i:=1;                       { aloitetaan ensimmisest merkist }

  Repeat                            { Toistetaan, kunnes koko annettu merk- }
                                    { kijono on lpikyty tai lytyy virhe. }
    Last:=Next;

{ SeuraavaFunktio palauttaa muuttujassa Next seuraavan tokenin. Numero
  palauttaa mahdollisesti lydetyn numeron. Index palauttaa mahdollisesti
  lydetyn vakion indeksin. Virhe on mahdollisen virhepaikan indeksi
  merkkijonossa.
}
    SeuraavaFunktio(Infix,i,Next,Numero,Index,Virhe);{ Haetaan seuraava olio. }
    If Virhe > 0 Then Exit;  { Virhe on 0, joss mitn vikaa ei ole lytynyt, }
                             { muuten Virhe on sen merkin indeksi, jonka      }
                             { kohdalla virhe havaittiin.                     }

{ Jos Next on miinusmerkki (tarkistetaan Etumerkki-aliohjelmassa), niin samalla
  tutkitaan, voiko se olla etumerkki. Jos Next on etumerkki, niin sen arvok-
  si vaihdetaan "unary-minus".
}
    Etumerkki(Next,Last);    { Jos Next on miinusmerkki, niin aliohjelma   }
                             { Etumerkki() tutkii, voiko se olla etumerkki }
                             { ja jos se voi, niin Next:iss palautetaan   }
                             { etumerkki. }
    If Not VoikoOllaPerakkain(Last,Next) Then Begin
                                     { Funktiolla VoikoOllaPerakkain(...)
                                     { tutkitaan, voiko kaksi }
                                     { lydetty oliota olla perkkin mie-  }
      Virhe:=Pred(i);                { lekkss lausekkeessa. }
      While Top <> Nil Do Begin      { Virheen sattuessa poistetaan dynaami- }
        Pino:=Top^.Seuraava;         { nen pino. }
        Dispose(Top);
        Top:=Pino;
      End;
      While Jono <> Nil Do Begin      { Virhetilanteessa poistetaan vir- }
        JononLoppu:=Jono^.Seuraava;   { heellinen laskulista. }
        Dispose(Jono);
        Jono:=JononLoppu;
      End;
      Exit;
    End;
    RightParen:=False; { ei oikeaa sulkua }     { Niin kauan kun seuraava    }
    While JononPrioriteetti(Next) <= PinonPrioriteetti(Top^.Alkio) Do Begin
                                                { olio (Next) on prioritee-  }
      If Top = Nil Then Begin                   { tiltaan pienempi kuin apu- }
                                                { pinossa oleva, laitetaan   }
        Virhe:=Pred(i);                         { olioita pinosta jonoon.    }
        While Top <> Nil Do Begin    { Virheen sattuessa poistetaan dynaami- }
          Pino:=Top^.Seuraava;       { nen pino. }
          Dispose(Top);
          Top:=Pino;
        End;
        While Jono <> Nil Do Begin    { Poistetaan virheellinen jono }
          JononLoppu:=Jono^.Seuraava;
          Dispose(Jono);
          Jono:=JononLoppu;
        End;
        Exit;
      End;
      Temp:=Top^.Alkio;       { Otetaan pinon plt alkio apumuuttujaan }
      Top:=Top^.Seuraava;     { ja poistetaan pinon huippu               }
      Dispose(Pino);
      Pino:=Top;
      If JononPrioriteetti(Next) < PinonPrioriteetti(Temp) Then Begin
                                   { jos uuden tokenin prioriteetti on ai- }
                                   { dosti pienempi kuin pinossa olevan,   }
                                   { niin pinosta laitetaan listaan token  }
        JononLoppu^.Alkio:=Temp;
        If JononLoppu^.Alkio = Vakio Then
          JononLoppu^.Arvo:=Numero
        Else If JononLoppu^.Alkio = Muuttuja Then
          JononLoppu^.Osoitin:=Index;
        New(JononLoppu^.Seuraava);
        JononLoppu:=JononLoppu^.Seuraava;
        JononLoppu^.Seuraava:=Nil;
      End { uuden tokenin prioriteetti oli pienempi kuin pinon }
      Else Begin { uuden on = tai suurempi, niin hyptn While-loopista   }
                 { pois. Tss vaiheessa tiedetn, ett uusi token (Next) }
                 { on pakko olla oikea sulku, joten laitetaan lippu mys   }
        RightParen:=True;     { plle.                                    }
        GoTo PoisSilmukasta;
      End;  { oikea sulku on lytynyt }
    End; { While -silmukka }
PoisSilmukasta:
    If Not RightParen Then Begin  { jos silmukka pttyi ilman hyppy, niin }
      New(Top);                   { laitetaan uusi token pinoon.            }
      Top^.Alkio:=Next;           { Tarkoittaa sit, ett uuden tokenin     }
      Top^.Seuraava:=Pino;        { prioriteetti on suurempi kuin pinon     }
      Pino:=Top;                  { huipun; Next laitetaan pinoon, josta se }
    End;                          { aikanaan siirtyy laskulistaan           }
  Until i > Length(Infix);     { Loopataan kunnes koko merkkijono on lpi-  }
                               { kyty.                                     }
  If Top <> Nil Then Begin     { Jos pino ei ole tyhj, niin jossain on sat- }
                               { tunut virhe (annettu lauseke on ollut syn-  }
                               { taksiltaan vr). Poistetaan viallinen     }
                               { pino ja samalla myskin viallinen lasku-    }
                               { lista ( sen on pakko olla virheellinen!)    }
    Virhe:=Pred(i);
    While Top <> Nil Do Begin      { Virheen sattuessa poistetaan dynaami- }
      Pino:=Top^.Seuraava;         { nen pino. }
      Dispose(Top);
      Top:=Pino;
    End;
    While Jono <> Nil Do Begin      { Virhetilanteessa poistetaan vir- }
      JononLoppu:=Jono^.Seuraava;   { heellinen laskulista. }
      Dispose(Jono);
      Jono:=JononLoppu;
    End;
  End;  { pino ei ollutkaan tyhj }
End; { Infix To Suffix }
